Subject: bug#46256: [feature/native-comp] AOT eln files ignored if run from build tree

From: Pip Cet <[email-masked]>
Date: Tue, 9 Mar 2021 08:35:18 +0000

On Tue, Mar 9, 2021 at 8:28 AM Andrea Corallo <[email-masked]> wrote:
> Pip Cet <[email-masked]> writes:
> > On Mon, Mar 8, 2021 at 8:47 PM Eli Zaretskii <[email-masked]> wrote:
> >> > From: Pip Cet <[email-masked]>
> >> > Date: Mon, 8 Mar 2021 18:32:55 +0000
> >> > Cc: Eli Zaretskii <[email-masked]>, [email-masked], [email-masked]
> >> >
> >> > What's saved_cu, actually?
> >>
> >> Not sure I understand the question.  Is the below what you wanted to
> >> see?
> >>
> >>   (gdb) p saved_cu
> >>   $6 = (Lisp_Object *) 0x6a5b2e7c <comp_unit>
> >
> > Yes! I believe we've found another bug.
> >
> > We were allocating comp_unit as a Lisp_Object **, but it's actually a
> > Lisp_Object.
>
> Uops!  Thanks I've installed this as 380ba045c4.

Thank you!

> BTW this is apparently fixing also my 32bit wide int GC issue.

Excellent, we were in luck there, then :-)

I think the only mystery left here, assuming the bug doesn't happen
again, is why GDB reports a different shared library address from what
LoadLibrary returned. I think it might be because GDB looks at the
actual mmap state, and the DLL header might have been read in rather
than mmapped.

Pip